; ******************************************************
; BASIC .ASM template file for AVR
; ******************************************************

.include "C:\VMLAB\include\m8def.inc"
.include "standard.inc"

; Define here the variables
;
.def  temp  =r16
.def	daten	=r17
.def	faktor=r18

.equ	fosc	=3686400

; Define here Reset and interrupt vectors, if any
;
.org 0x0
reset:  rjmp start

.org	URXCaddr
	rjmp	empfange

; Program starts here after Reset
;
.org	$13
start:
   INIT_SP	 ; Initialisiere Stackpointer
   INIT_SER  9600,fosc
   sbi 	UCSRB,RXCIE	; Schalte "Daten empfangen"-Interrupt frei
	sbi	DDRB,3	; PB3 als Ausgang
	ldi	temp,((1<<WGM20) | (1<<WGM21) | (1<<COM21)+1) ; schnelle PWM, nichtinvertiert, voller CPU-Takt
	out	TCCR2,temp
	ldi	daten,128 ; anfngliche Helligkeit
	ldi	faktor,28 ; Helligkeitsschritte
	rcall aendern
	ldi	temp,((1<< SE) | (0b000*(1 << SM0))); enable sleep mode, standby mode
	out	MCUCR,temp
	sei	; erlaube Interrupts
forever:
   sleep
rjmp forever

empfange:
	in		temp,UDR
	cpi   temp,'+'
	brne	emm
	cpi	daten,255
	breq	emq
	inc	daten
	rjmp	emf
emm:
	cpi	temp,'-'
	brne	ema
	cpi	daten,0
	breq	emq
	dec	daten
	rjmp 	emf
ema:
	cpi	temp,'a'
	brne	ems
emone:
	ldi	daten,255
	rjmp	emf
ems:
	cpi	temp,32 ; Space
	brne	emz
	cpi	daten,0
	breq	emone
	ldi	daten,0
	rjmp	emf
emz:
	subi	temp,'0'
	brlo	emq
	cpi	temp,10
	brge	emq
	mul	temp,faktor
	mov	daten,r0
emf:
	rcall aendern
emq:
	reti
	
aendern:
	out OCR2,daten	
	ret
